<template>
  <div class="modal" :class="{'is-active': active}">
    <div class="modal-background"></div>
    <div class="modal-card">
      <header class="modal-card-head">
        <h1 class="modal-card-title">Remove instance</h1>
      </header>
      <section class="modal-card-body">
        <p>
          This will remove your instance for service:
          <span
            class="has-text-weight-bold"
          >&nbsp;{{ service.name }}</span>
        </p>
        <p>
          To remove please enter
          <span class="has-text-weight-bold">&nbsp;{{ dashboard_id }}&nbsp;</span>below
        </p>
        <div class="field">
          <div class="control">
            <input
              type="text"
              class="input is-danger"
              :placeholder="dashboard_id"
              v-model.trim="userInput"
            />
          </div>
        </div>
        <p class="has-text-weight-bold">
          <span class="is-uppercase">Note:</span> This action cannot be undone
        </p>
      </section>
      <footer class="modal-card-foot">
        <button
          v-on:click="deprovision(instance.uuid)"
          class="button is-danger"
          :disabled="dashboard_id != userInput"
        >I understand - delete this service</button>
        <button class="button is-white" v-on:click="close">Cancel</button>
      </footer>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import { ServiceInstance } from "../services/arbalo_extensions/instances";
import { CatalogItem, emptyCatalogItem } from "../services/osb/catalog";

@Component
export default class AnInstanceDeprovisionModal extends Vue {
  userInput: string = "";

  @Prop({ default: false }) active!: boolean;
  @Prop() instance!: ServiceInstance;

  get dashboard_id() {
    return this.instance.dashboard_url.split(".")[0];
  }

  get service(): CatalogItem {
    let s = this.$store.getters["catalog/getOfferingByID"](
      this.instance.uuid
    );

    if (!s) {
      s = emptyCatalogItem();
    }

    return s;
  }

  reset() {
    this.userInput = "";
  }

  close() {
    this.$emit("closeModal");
  }

  deprovision() {
    // Trigger deprovisioning in backend
    this.$store.dispatch("catalog/deprovision", {
      instanceID: this.instance.uuid,
      serviceID: this.instance.service_uuid,
      planID: this.instance.plan_uuid
    });
    // Remove instance from list in frontend
    this.$store.dispatch("catalog/fetchInstances", {
      projectUUID: this.$store.state.activeProject.uuid
    });
    this.close();
    this.reset();
  }
}
</script>

<style lang="scss" scoped>
</style>
